program VGAMTRR;
{This program checks and sets necessary MTTRs for WC mode of banked VGA framebuffer (only for AMD!)}
{$G+,N+,E-}

var
 geax, gedx: longint;

const
   HexDigits: array[0..15] of char = '0123456789ABCDEF';

function IntToHex(value: Longint): string;
var
 i: integer;
 result: string[8];
begin
  result := '00000000';
  for i := 0 to 7 do
  begin
   result[8 - i] := HexDigits[value and 15];
   value := value shr 4;
  end ;
 while value <> 0 do
 begin
   result := HexDigits[value and 15] + result;
   value := value shr 4;
 end;
 IntToHex := '0x'+ result;
end;

procedure WriteMSR(reax, redx, msr: longint);
var
 recx: longint;
begin
 recx := msr;
 asm
  DB $66
  mov ax,word ptr [reax]
  DB $66
  mov dx,word ptr [redx]
  DB $66
  mov cx,word ptr [recx]
  DB $0F,$30 {wrmsr}
 end;
end;

procedure ReadMSR(var reax: longint; var redx: longint; msr: longint);
var
 recx: longint;
begin
 recx := msr;
 asm
  DB $66
  mov cx,word ptr [recx]
  DB $0F,$32 {rdmsr}
  les di,reax
  DB $66
  mov word ptr es:[di],ax
  les di,redx
  DB $66
  mov word ptr es:[di],dx
 end;
end;

begin
  Writeln('Checks and sets necessary MTTRs for WC mode of banked VGA framebuffer (only for AMD!)');
  Writeln;

  ReadMSR(geax, gedx, $C0010113);
  writeln('Original SMMMask EAX value: ', IntToHex(geax));
  WriteMSR(geax or $10, gedx, $C0010113);
  ReadMSR(geax, gedx, $C0010113);
  writeln('Modified SMMMask EAX value: ', IntToHex(geax));
  writeln;  
  ReadMSR(geax, gedx, $2FF);
  writeln('Original MTRRdefType value: ', IntToHex(geax));
  writeln('All MTRRs Enabled: ', (geax and $800) <> 0);
  writeln('Fixed MTRRs Enabled: ', (geax and $400) <> 0);
  WriteMSR($00000C00, $00000000, $2FF);
  ReadMSR(geax, gedx, $2FF);
  writeln('Modified MTRRdefType value: ', IntToHex(geax));
  writeln('All MTRRs Enabled: ', (geax and $800) <> 0);
  writeln('Fixed MTRRs Enabled: ', (geax and $400) <> 0);
  writeln;
  ReadMSR(geax, gedx, $259);
  writeln('Original VGA A0000-AFFFF: ', IntToHex(geax));
  writeln('Original VGA B0000-BFFFF: ', IntToHex(gedx));
  WriteMSR($01010101, $01010101, $259);
  ReadMSR(geax, gedx, $259);
  writeln('Modified VGA A0000-AFFFF: ', IntToHex(geax));
  writeln('Modified VGA B0000-BFFFF: ', IntToHex(gedx));
  writeln;
  writeln('Pattern ''01010101'' means fixed range MTRR set to Write Combining');
  Writeln;
end.